#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h> 
#include <string.h>
#include <sys/stat.h>
#include <errno.h>
#include <linux/fs.h>


extern uint8_t* blk_buf;

int sw_comp_display (const int fd_dev, const char* pattern, const int start_blk, const int len)
{
	printf ("%15d\t%15d\t%15d\n", start_blk, start_blk + len - 1, len);
	return 0;
}

int sw_comp (const int fd_dev, const char* pattern, const int start_blk, const int blks)
{
	int match = 0;
	off64_t ofs = 0, len = 0;

	ofs = start_blk;
	ofs = ofs * 4096;
	if (lseek64 (fd_dev, ofs, SEEK_SET) < 0) {
		fprintf (stderr, "lseek failed: start_blk=%d %s\n", start_blk, strerror (errno));
		return -1;
	}

	ofs = 0;
	len = blks * 4096;
	while (ofs < len) {
		ofs += read (fd_dev, blk_buf + ofs, len - ofs);
	}

	for (ofs = 0; ofs <= len - strlen (pattern); ofs++) {
		if (bcmp (blk_buf + ofs, pattern, strlen (pattern)) == 0) {
			match++;
		}
	}

	return match;
}

