#ifndef _BLUEDBM_DEBUG_H
#define _BLUEDBM_DEBUG_H

#include "platform.h"

#ifdef CONFIG_ENABLE_MSG
	#define bdbm_msg(fmt, ...)  \
		do {    \
			printk(KERN_INFO "bdbm: " fmt "\n", ##__VA_ARGS__);  \
		} while (0);
#else
	#define bdbm_msg(fmt, ...)
#endif
#define bdbm_warning(fmt, ...)  \
	do {    \
		printk(KERN_ERR "bdbm-warning: " fmt " (%d@%s)\n", ##__VA_ARGS__, __LINE__, __FILE__);    \
	} while (0);
#define bdbm_error(fmt, ...)  \
	do {    \
		printk(KERN_ERR "bdbm-error: " fmt " (%d@%s)\n", ##__VA_ARGS__, __LINE__, __FILE__);    \
	} while (0);
#define bdbm_warn_on(condition) \
	do { 	\
		if (condition)	\
			bdbm_warning ("bdbm_warn_on"); \
		WARN_ON(condition); \
	} while (0);


#ifdef CONFIG_ENABLE_DEBUG
	#define bdbm_bug_on(condition)  \
		do { 	\
			if (condition)	\
				bdbm_error ("bdbm_bug_on"); \
			BUG_ON(condition); \
		} while (0);
	#define bdbm_dbg_msg(fmt, ...)  \
		do {    \
			printk(KERN_INFO "bdbm: " fmt " (%d@%s)\n", ##__VA_ARGS__, __LINE__, __FILE__);    \
		} while (0);
#else
	#define bdbm_bug_on(condition)
	#define bdbm_dbg_msg(fmt, ...)
#endif

#endif /* _BLUEDBM_DEBUG_H */
