#ifndef _BLUEDBM_IOCTL_H
#define _BLUEDBM_IOCTL_H

struct phyaddr {
	uint64_t logical_addr;
	uint64_t channel_no;
	uint64_t chip_no;
	uint64_t block_no;
	uint64_t page_no;
	uint32_t offset;
	uint32_t length;
};

#define BDBM_BADBLOCK_SCAN _IOR(0, 0, int)
#define BDBM_BADBLOCK_SCAN_CHECK _IOR(0, 1, int)
#define BDBM_GET_PHYADDR _IOR(0, 2, struct phyaddr)

#ifdef MODULE
/* kernel module */

#ifndef HDIO_GETGEO_BIG /* for backward-compatibility */
#define HDIO_GETGEO_BIG	0x330
#endif

#ifndef HDIO_GETGEO_BIG_RAW
#define HDIO_GETGEO_BIG_RAW	0x331
#endif

int bdbm_blk_ioctl (struct block_device *bdev, fmode_t mode, unsigned cmd, unsigned long arg);
int bdbm_blk_getgeo (struct block_device *bdev, struct hd_geometry* geo);

#endif	/* MODULE */

#endif  /* _BLUEDBM_IOCTL_H */
