#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/kthread.h>
#include <linux/delay.h>
#include <linux/blkdev.h>

#include <linux/pci.h>          /* pci device types, fns, etc. */
#include <linux/device.h>
#include <linux/cdev.h>
#include "../debug.h"

/*#include "../xbsv/cpp/portal_offsets.h"*/
#include "../xbsv/cpp/portal.h"
#include "../xbsv/drivers/pcieportal/pcieportal.h"
#include "../xbsv/drivers/portalmem/portalmem.h"
/*#include "/home/chamdoo/simple_manual/vc707/jni/SimpleIndicationWrapperOffsets.h"*/
/*#include "/home/chamdoo/simple_manual/vc707/jni/SimpleRequestProxyOffsets.h"*/

#include "/home/chamdoo/memread_manual_old/vc707/jni/GeneratedTypes.h"

/* for pcieportal */
extern tBoard* get_pcie_portal_descriptor(void);

static tBoard* board = NULL;

volatile uint32_t* baseaddr; 


static struct task_struct *thread1 = NULL;


/*
 * MEMREAD_MANUAL_MANAGER
 */

#include <linux/slab.h>
#include <linux/dma-buf.h>

static int burstLen = 16;
/*static int numWords = 0x1240000/4; // make sure to allocate at least one entry of each size*/
#define numWords 0x1240000/4 // make sure to allocate at least one entry of each size
/*static size_t test_sz  = numWords*sizeof(unsigned int);*/
#define test_sz  numWords*sizeof(uint32_t)
static size_t alloc_sz = test_sz;


static uint64_t localmanager_mtCnt;
static DmaDbgRec localmanager_dbgRec;

static int local_manager_handle = 1;
static int trace_memory;// = 1;

#define MAX_INDARRAY 4
typedef int (*INDFUNC)(volatile uint32_t *map_base, uint32_t channel);
/*static PortalInternal *intarr[MAX_INDARRAY];*/
static INDFUNC indfn[MAX_INDARRAY];

/* from portalmem */
extern struct dma_buf *portalmem_dmabuffer_create(unsigned long len, unsigned long align);

/* for thread */
static struct task_struct *tid = NULL;

/* semaphores */
#include <linux/semaphore.h>

struct semaphore localmanager_confSem;
struct semaphore localmanager_mtSem;
struct semaphore localmanager_dbgSem;
struct semaphore test_sem;


struct pa_buffer {
  size_t          size;
  struct mutex    lock;
  int             kmap_cnt;
  void            *vaddr;
  struct sg_table *sg_table;
};

static uint32_t _buf[1024];

static int DmaIndicationWrapper_handleMessage(volatile uint32_t *map_base, uint32_t channel)
{    
    switch (channel) { 
    case CHAN_NUM_DmaIndicationWrapper_configResp: 
    { 
		int i;
        struct {
            uint32_t pointer:32;
            uint64_t msg:64;
        } payload;
        for (i = (12/4)-1; i >= 0; i--)
            _buf[i] = READL(this, &map_base[PORTAL_IND_FIFO(CHAN_NUM_DmaIndicationWrapper_configResp)]);
        i = 0;
        payload.msg = (uint64_t)(_buf[i]);
        i++;
        payload.msg |= (uint64_t)(((uint64_t)(_buf[i])<<32));
        i++;
        payload.pointer = (uint32_t)(_buf[i]);
        i++;
		/*sem_post(&localmanager_confSem);*/
		up (&localmanager_confSem);
        break;
    }

    case CHAN_NUM_DmaIndicationWrapper_addrResponse: 
    { 
		int i;
        struct {
            uint64_t physAddr:64;
        } payload;
        for (i = (8/4)-1; i >= 0; i--)
            _buf[i] = READL(this, &map_base[PORTAL_IND_FIFO(CHAN_NUM_DmaIndicationWrapper_addrResponse)]);
        i = 0;
        payload.physAddr = (uint64_t)(_buf[i]);
        i++;
        payload.physAddr |= (uint64_t)(((uint64_t)(_buf[i])<<32));
        i++;
        printk("DmaIndication_addrResponse(physAddr=%llu)\n", payload.physAddr);
        break;
    }

    case CHAN_NUM_DmaIndicationWrapper_badPointer: 
    { 
		int i;
        struct {
            uint32_t pointer:32;
        } payload;
        for (i = (4/4)-1; i >= 0; i--)
            _buf[i] = READL(this, &map_base[PORTAL_IND_FIFO(CHAN_NUM_DmaIndicationWrapper_badPointer)]);
        i = 0;
        payload.pointer = (uint32_t)(_buf[i]);
        i++;
        printk("DmaIndication_badPointer(pointer=%x)\n", payload.pointer);
        break;
    }

    case CHAN_NUM_DmaIndicationWrapper_badAddrTrans: 
    { 
        int i = 0;
        struct {
            uint32_t pointer:32;
            uint64_t offset:64;
            uint64_t barrier:64;
        } payload;
        for (i = (20/4)-1; i >= 0; i--)
            _buf[i] = READL(this, &map_base[PORTAL_IND_FIFO(CHAN_NUM_DmaIndicationWrapper_badAddrTrans)]);
        i = 0;
        payload.barrier = (uint64_t)(_buf[i]);
        i++;
        payload.barrier |= (uint64_t)(((uint64_t)(_buf[i])<<32));
        i++;
        payload.offset = (uint64_t)(_buf[i]);
        i++;
        payload.offset |= (uint64_t)(((uint64_t)(_buf[i])<<32));
        i++;
        payload.pointer = (uint32_t)(_buf[i]);
        i++;
        printk("DmaIndication_badAddrTrans(pointer=%x, offset=%llu barrier=%llu\n", payload.pointer, payload.offset, payload.barrier);
        break;
    }

    case CHAN_NUM_DmaIndicationWrapper_badPageSize: 
    { 
        int i = 0;
        struct {
            uint32_t pointer:32;
            uint32_t sz:32;
        } payload;
        for (i = (8/4)-1; i >= 0; i--)
            _buf[i] = READL(this, &map_base[PORTAL_IND_FIFO(CHAN_NUM_DmaIndicationWrapper_badPageSize)]);
        i = 0;
        payload.sz = (uint32_t)(_buf[i]);
        i++;
        payload.pointer = (uint32_t)(_buf[i]);
        i++;
        printk("DmaIndication_badPageSize(pointer=%x, len=%x)\n", payload.pointer, payload.sz);
        break;
    }

    case CHAN_NUM_DmaIndicationWrapper_badNumberEntries: 
    { 
        int i = 0;
        struct {
            uint32_t pointer:32;
            uint32_t sz:32;
            uint32_t idx:32;
        } payload;
        for (i = (12/4)-1; i >= 0; i--)
            _buf[i] = READL(this, &map_base[PORTAL_IND_FIFO(CHAN_NUM_DmaIndicationWrapper_badNumberEntries)]);
        i = 0;
        payload.idx = (uint32_t)(_buf[i]);
        i++;
        payload.sz = (uint32_t)(_buf[i]);
        i++;
        payload.pointer = (uint32_t)(_buf[i]);
        i++;
        printk("DmaIndication_badNumberEntries(pointer=%x, len=%x, idx=%x)\n", payload.pointer, payload.sz, payload.idx);
        break;
    }

    case CHAN_NUM_DmaIndicationWrapper_badAddr: 
    { 
		int i;
        struct {
            uint32_t pointer:32;
            uint64_t offset:64;
            uint64_t physAddr:64;
        } payload;
        for (i = (20/4)-1; i >= 0; i--)
            _buf[i] = READL(this, &map_base[PORTAL_IND_FIFO(CHAN_NUM_DmaIndicationWrapper_badAddr)]);
        i = 0;
        payload.physAddr = (uint64_t)(_buf[i]);
        i++;
        payload.physAddr |= (uint64_t)(((uint64_t)(_buf[i])<<32));
        i++;
        payload.offset = (uint64_t)(_buf[i]);
        i++;
        payload.offset |= (uint64_t)(((uint64_t)(_buf[i])<<32));
        i++;
        payload.pointer = (uint32_t)(_buf[i]);
        i++;
        printk("DmaIndication_badAddr(pointer=%x offset=%llu physAddr=%llu)\n", payload.pointer, payload.offset, payload.physAddr);
        break;
    }

    case CHAN_NUM_DmaIndicationWrapper_reportStateDbg: 
    { 
        int i;
        struct {
            DmaDbgRec rec;
        } payload;
        for (i = (16/4)-1; i >= 0; i--)
            _buf[i] = READL(this, &map_base[PORTAL_IND_FIFO(CHAN_NUM_DmaIndicationWrapper_reportStateDbg)]);
        i = 0;
        payload.rec.w = (uint32_t)(_buf[i]);
        i++;
        payload.rec.z = (uint32_t)(_buf[i]);
        i++;
        payload.rec.y = (uint32_t)(_buf[i]);
        i++;
        payload.rec.x = (uint32_t)(_buf[i]);
        i++;
        //printk("reportStateDbg: {x:%08x y:%08x z:%08x w:%08x}\n", payload.rec.x,payload.rec.y,payload.rec.z,payload.rec.w);
        localmanager_dbgRec = payload.rec;
        printk("dbgResp: %08x %08x %08x %08x\n", localmanager_dbgRec.x, localmanager_dbgRec.y, localmanager_dbgRec.z, localmanager_dbgRec.w);
		/*sem_post(&localmanager_dbgSem);*/
		up (&localmanager_dbgSem);
        break;
    }

    case CHAN_NUM_DmaIndicationWrapper_reportMemoryTraffic: 
    { 
        int i = 0;
        struct {
            uint64_t words:64;
        } payload;
        for (i = (8/4)-1; i >= 0; i--)
            _buf[i] = READL(this, &map_base[PORTAL_IND_FIFO(CHAN_NUM_DmaIndicationWrapper_reportMemoryTraffic)]);
        i = 0;
        payload.words = (uint64_t)(_buf[i]);
        i++;
        payload.words |= (uint64_t)(((uint64_t)(_buf[i])<<32));
        i++;
        //printk("reportMemoryTraffic: words=%llu\n", payload.words);
        localmanager_mtCnt = payload.words;
		/*sem_post(&localmanager_mtSem);*/
		up (&localmanager_mtSem);
        break;
    }

    case CHAN_NUM_DmaIndicationWrapper_tagMismatch: 
    { 
        int i = 0;
        struct {
            ChannelType x;
            uint32_t a:32;
            uint32_t b:32;
        } payload;
        for (i = (12/4)-1; i >= 0; i--)
            _buf[i] = READL(this, &map_base[PORTAL_IND_FIFO(CHAN_NUM_DmaIndicationWrapper_tagMismatch)]);
        i = 0;
        payload.b = (uint32_t)(_buf[i]);
        i++;
        payload.a = (uint32_t)(_buf[i]);
        i++;
        payload.x = (ChannelType)(((_buf[i])&0x1ul));
        i++;
        printk("tagMismatch: %s %d %d\n", payload.x==ChannelType_Read ? "Read" : "Write", payload.a, payload.b);
        break;
    }

    default:
        printk("DmaIndicationWrapper_handleMessage: unknown channel 0x%x\n", channel);
        return 0;
    }
    return 0;
}

static int MemreadIndicationWrapper_handleMessage(volatile uint32_t *map_base, uint32_t channel)
{    
    switch (channel) {
    case CHAN_NUM_MemreadIndicationWrapper_readDone: 
    { 
        int i = 0;
        struct {
            uint32_t mismatchCount:32;
        } payload;
        for (i = (4/4)-1; i >= 0; i--)
            _buf[i] = READL(this, &map_base[PORTAL_IND_FIFO(CHAN_NUM_MemreadIndicationWrapper_readDone)]);
        i = 0;
        payload.mismatchCount = (uint32_t)(_buf[i]);
        i++;
         printk( "Memread_readDone(mismatch = %x)\n", payload.mismatchCount);
		 /*sem_post(&test_sem);*/
		 up (&test_sem);
        break;
    }

    default:
        printk("MemreadIndicationWrapper_handleMessage: unknown channel 0x%x\n", channel);
        return 0;
    }
    return 0;
}

static int DmaConfigProxyStatus_handleMessage(volatile uint32_t *map_base, uint32_t channel)
{    
    uint32_t _buf[1024];
    
    switch (channel) { 
    case CHAN_NUM_DmaConfigProxyStatus_putFailed: 
    { 
		int i;
        struct {
            uint32_t v:32;
        } payload;
        const char* methodNameStrings[] = {"sglist", "region", "addrRequest", "getStateDbg", "getMemoryTraffic"};
        for (i = (4/4)-1; i >= 0; i--)
            _buf[i] = READL(this, &map_base[PORTAL_IND_FIFO(CHAN_NUM_DmaConfigProxyStatus_putFailed)]);
        printk("putFailed: %s\n", methodNameStrings[payload.v]);
        break;
    }

    default:
        printk("DmaConfigProxyStatus_handleMessage: unknown channel 0x%x\n", channel);
        return 0;
    }
    return 0;
}

static int MemreadRequestProxyStatus_handleMessage(volatile uint32_t *map_base, uint32_t channel)
{    
    switch (channel) {
    case CHAN_NUM_MemreadRequestProxyStatus_putFailed: 
    { 
		int i;
        struct {
            uint32_t v:32;
        } payload;
        const char* methodNameStrings[] = {"startRead"};
        for (i = (4/4)-1; i >= 0; i--)
            _buf[i] = READL(this, &map_base[PORTAL_IND_FIFO(CHAN_NUM_MemreadRequestProxyStatus_putFailed)]);
        printk("putFailed: %s\n", methodNameStrings[payload.v]);
        break;
    }

    default:
        printk("MemreadRequestProxyStatus_handleMessage: unknown channel 0x%x\n", channel);
        return 0;
    }
    return 0;
}

/*
static void manual_event(void)
{
	int i;
	for (i = 0; i < 2; i++) {
		volatile uint32_t *map_base = (volatile uint32_t *)(baseaddr + (i+1)*(1<<16)/4);
		uint32_t queue_status;
		while ((queue_status = map_base[IND_REG_QUEUE_STATUS])) {
			uint32_t int_src = map_base[IND_REG_INTERRUPT_FLAG];
			uint32_t int_en  = map_base[IND_REG_INTERRUPT_MASK];
			bdbm_msg("(%d) about to receive messages int=%08x en=%08x qs=%08x", i, int_src, int_en, queue_status);
			if (i == 1)
				indication_handleMessage(map_base, queue_status-1);
			else
				request_handleMessage(map_base, queue_status-1);
		}
	}
}
*/

static void manual_event(void)
{
	int i;
	/*for (int i = 0; i < sizeof(intarr)/sizeof(intarr[i]); i++) {*/
	for (i = 0; i < MAX_INDARRAY; i++) {
		/*PortalInternal *instance = intarr[i];*/
	  volatile uint32_t *map_base = (volatile uint32_t *)(baseaddr + (i+1)*(1<<16)/4);
      uint32_t queue_status;
	  /*while ((queue_status= instance->map_base[IND_REG_QUEUE_STATUS])) {*/
	  while ((queue_status = map_base[IND_REG_QUEUE_STATUS])) {
        uint32_t int_src = map_base[IND_REG_INTERRUPT_FLAG];
        uint32_t int_en  = map_base[IND_REG_INTERRUPT_MASK];
		/*uint32_t ind_count  = map_base[IND_REG_INTERRUPT_COUNT];*/
        printk("(%d:%s) about to receive messages int=%08x en=%08x qs=%08x indfn %p\n", i, "", int_src, int_en, queue_status, indfn[i]);
        if (indfn[i])
            indfn[i](map_base, queue_status-1);
      }
    }
}

int kthread_worker (void* arg) 
{
	printk ("kthread_worker starts\n");
    while (1) {
        struct timeval timeout;
        timeout.tv_sec = 0;
        timeout.tv_usec = 10000;
        manual_event();

		/*select(0, NULL, NULL, NULL, &timeout);*/

		msleep(10);

		if (kthread_should_stop()) {
			printk ("exit from kthread_worker\n");
			return 0;
		}
    }
	printk ("kthread_worker ends\n");
	return 0;
}

/*static int local_manager_reference(PortalAlloc* pa)*/
static int32_t local_manager_reference(PortalAlloc* pa)
{
  const int PAGE_SHIFT0 = 12;
  const int PAGE_SHIFT4 = 16;
  const int PAGE_SHIFT8 = 20;
  uint64_t regions[3] = {0,0,0};
  uint64_t shifts[3] = {PAGE_SHIFT8, PAGE_SHIFT4, PAGE_SHIFT0};
  /*int id = local_manager_handle++;*/
  /*int ne = pa->header.numEntries;*/
  /*int size_accum = 0;*/
  /*int i = 0;*/
  int32_t id = local_manager_handle++;
  int32_t ne = pa->header.numEntries;
  int32_t size_accum = 0;
  int32_t i = 0;


  uint64_t border = 0;
  unsigned char entryCount = 0;
  struct {
	  uint64_t border;
	  unsigned char idxOffset;
  } borders[3];


  volatile uint32_t *map_base = (volatile uint32_t *)(baseaddr + (2+1)*(1<<16)/4);

  // HW interprets zeros as end of sglist
  pa->entries[ne].dma_address = 0;
  pa->entries[ne].length = 0;
  pa->header.numEntries++;
  if (trace_memory)
    printk("local_manager_reference id=%08x, numEntries:=%d len=%08lx)\n", id, ne, pa->header.size);
  for(i = 0; i < pa->header.numEntries; i++){
    dma_addr_t addr;
    DmaEntry *e = &(pa->entries[i]);
    switch (e->length) {
    case (1<<PAGE_SHIFT0):
      regions[2]++;
      break;
    case (1<<PAGE_SHIFT4):
      regions[1]++;
      break;
    case (1<<PAGE_SHIFT8):
      regions[0]++;
      break;
    case (0):
      break;
    default:
      printk("local_manager_unsupported sglist size %x\n", e->length);
    }
    addr = e->dma_address;
    if (trace_memory)
      printk("local_manager_sglist(id=%08x, i=%d dma_addr=%08lx, len=%08x)\n", id, i, (long)addr, e->length);
    {
	/*unsigned int buf[128];*/
	int loop = 0;
	uint32_t buf[128];
    struct {
        uint32_t pointer:32;
        uint64_t addr:64;
        uint32_t len:32;
    } payload;
    payload.pointer = id;
    payload.addr = addr;
    payload.len = e->length;

	/*printk ("pointer:%x addr:%x len:%x\n", payload.pointer, payload.addr, payload.len);*/

    loop = 0;
    buf[loop++] = payload.len;
    buf[loop++] = payload.addr;
    buf[loop++] = (payload.addr>>32);
    buf[loop++] = payload.pointer;
    for (loop = 16/4-1; loop >= 0; loop--)
		map_base[PORTAL_REQ_FIFO(CHAN_NUM_DmaConfigProxy_sglist)] = buf[loop];
		/*intarr[2]->map_base[PORTAL_REQ_FIFO(CHAN_NUM_DmaConfigProxy_sglist)] = buf[i];*/
    };
    size_accum += e->length;
    // printk("%s:%d sem_wait\n", __FILE__, __LINE__);
	/*sem_wait(&localmanager_confSem);*/
	down_interruptible (&localmanager_confSem);
  }

  for(i = 0; i < 3; i++){
	  if (i == 0)
		  borders[i].idxOffset = 0;
	  else
		  borders[i].idxOffset = entryCount - ((border >> shifts[i])&0xff);

	  border += regions[i]*(1<<shifts[i]);
	  borders[i].border = border;
	  entryCount += regions[i];
  }
  if (trace_memory) {
	  printk("regions %d (%llu %llu %llu)\n", id,regions[0], regions[1], regions[2]);
	  printk("borders %d (%llu %llu %llu)\n", id,borders[0].border, borders[1].border, borders[2].border);
  }

  {
    uint32_t buf[128];
    struct {
        uint32_t pointer:32;
        uint64_t barr8:64;
        uint32_t off8:32;
        uint64_t barr4:64;
        uint32_t off4:32;
        uint64_t barr0:64;
        uint32_t off0:32;
    } payload;
    payload.pointer = id;
    payload.barr8 = borders[0].border;
    payload.off8 = borders[0].idxOffset;
    payload.barr4 = borders[1].border;
    payload.off4 = borders[1].idxOffset;
    payload.barr0 = borders[2].border;
    payload.off0 = borders[2].idxOffset;

	i = 0;
    buf[i++] = payload.off0;
    buf[i++] = payload.barr0;
    buf[i++] = (payload.barr0>>32);
    buf[i++] = payload.off4;
    buf[i++] = payload.barr4;
    buf[i++] = (payload.barr4>>32);
    buf[i++] = payload.off8;
    buf[i++] = payload.barr8;
    buf[i++] = (payload.barr8>>32);
    buf[i++] = payload.pointer;
    for (i = 40/4-1; i >= 0; i--)
		/*intarr[2]->map_base[PORTAL_REQ_FIFO(CHAN_NUM_DmaConfigProxy_region)] = buf[i];*/
		map_base[PORTAL_REQ_FIFO(CHAN_NUM_DmaConfigProxy_region)] = buf[i];
  };
  /*sem_wait(&localmanager_confSem);*/
  down_interruptible (&localmanager_confSem);
  return id;
}

int bdbm_test_thread_memread_fn (void* arg) 
{
	/*int i = 0;*/
	volatile uint32_t* baseaddr_test = NULL;
	PortalAlloc *srcAlloc;
	uint32_t *srcBuffer = NULL;
	uint32_t ref_srcAlloc;

	board = get_pcie_portal_descriptor ();
	baseaddr = board->bar2io;

	
	/* init semaphores */
	sema_init (&localmanager_confSem, 1);
	sema_init (&localmanager_mtSem, 1);
	sema_init (&localmanager_dbgSem, 1);
	sema_init (&test_sem, 1);

  	down_interruptible (&localmanager_confSem);
  	down_interruptible (&localmanager_mtSem);
  	down_interruptible (&localmanager_dbgSem);
  	down_interruptible (&test_sem);

	baseaddr_test = baseaddr + (0+1)*(1<<16)/4;
	baseaddr_test[IND_REG_INTERRUPT_MASK] = 1;
	baseaddr_test[IND_REG_INTERRUPT_MASK] = 0;

	baseaddr_test = baseaddr + (1+1)*(1<<16)/4;
	baseaddr_test[IND_REG_INTERRUPT_MASK] = 1;
	baseaddr_test[IND_REG_INTERRUPT_MASK] = 0;

	baseaddr_test = baseaddr + (2+1)*(1<<16)/4;
	baseaddr_test[IND_REG_INTERRUPT_MASK] = 1;
	baseaddr_test[IND_REG_INTERRUPT_MASK] = 0;

	baseaddr_test = baseaddr + (3+1)*(1<<16)/4;
	baseaddr_test[IND_REG_INTERRUPT_MASK] = 1;
	baseaddr_test[IND_REG_INTERRUPT_MASK] = 0;


  	indfn[0] = DmaIndicationWrapper_handleMessage;
  	indfn[1] = MemreadIndicationWrapper_handleMessage;
  	indfn[2] = DmaConfigProxyStatus_handleMessage;
  	indfn[3] = MemreadRequestProxyStatus_handleMessage;

	srcAlloc = (PortalAlloc *)vmalloc(sizeof(PortalAlloc));
  	memset(srcAlloc, 0, sizeof(PortalAlloc));
  	srcAlloc->header.size = alloc_sz;

	{
		// code for PA_ALLOC
		size_t align = 4096;
		struct dma_buf *dmabuf;

		printk("%s, srcAlloc.size=%zd\n", __FUNCTION__, srcAlloc->header.size);
		srcAlloc->header.size = PAGE_ALIGN(round_up(srcAlloc->header.size, align));
		dmabuf = portalmem_dmabuffer_create(srcAlloc->header.size, align);
		if (IS_ERR(dmabuf))
			return PTR_ERR(dmabuf);
		printk("pa_get_dma_buf %p %zd\n", dmabuf->file, dmabuf->file->f_count.counter);
		srcAlloc->header.numEntries = ((struct pa_buffer *)dmabuf->priv)->sg_table->nents;
		srcAlloc->header.fd = dma_buf_fd(dmabuf, O_CLOEXEC);
		if (srcAlloc->header.fd < 0)
			dma_buf_put(dmabuf);
	}

	{
		// code for PA_DMA_ADDRESSES
		struct scatterlist *sg;
		int i;
		struct file *f = fget(srcAlloc->header.fd);
		struct sg_table *sgtable = ((struct pa_buffer *)((struct dma_buf *)f->private_data)->priv)->sg_table;

		struct page* pg;
		uint32_t* vaddr;
		int k = 0;

		for_each_sg(sgtable->sgl, sg, sgtable->nents, i) {
			int j = 0;
			pg = sg_page (sg);
			vaddr = (uint32_t*)page_address (pg);

			srcAlloc->entries[i].dma_address = sg_phys(sg);
			srcAlloc->entries[i].length = sg->length;

			printk ("hw_addr = %p virt_addr = %p (len=%x)\n", 
				(void*)srcAlloc->entries[i].dma_address, vaddr, srcAlloc->entries[i].length);

			for(j = 0; j < sg->length/4; j++) {
				vaddr[j] = k;
				k++;
			}
			for(j = 0; j < sg->length; j++){
				char foo = *(((volatile char *)vaddr)+j);
				asm volatile("clflush %0" :: "m" (foo));
			}
		}
		fput(f);

		printk ("k=%d, numWords=%d\n", k, numWords);

		asm volatile("mfence");
	}

	printk( "Main: creating exec thread\n");
	printk("tid = %p\n", tid);
	wake_up_process (tid);

	/*
	for (i = 0; i < numWords; i++) {
		srcBuffer[i] = i;
	}

	{
		for(i = 0; i < srcAlloc->header.size; i++){
			char foo = *(((volatile char *)srcBuffer)+i);
			asm volatile("clflush %0" :: "m" (foo));
		}
		asm volatile("mfence");
	}
	*/

	ref_srcAlloc = local_manager_reference(srcAlloc);
	printk( "Main: starting read %08x\n", numWords);
	{
		/*unsigned int buf[128];*/
		uint32_t buf[128];
		int i = 0;
		volatile uint32_t *map_base = (volatile uint32_t *)(baseaddr + (3+1)*(1<<16)/4);

		buf[i++] = 1; 
		buf[i++] = burstLen;
		buf[i++] = numWords;
		buf[i++] = ref_srcAlloc;
		//sendMessage(&msg);
		for (i = 16/4-1; i >= 0; i--)
			/*intarr[0]->map_base[PORTAL_REQ_FIFO(CHAN_NUM_MemreadRequestProxy_startRead)] = buf[i];*/
			map_base[PORTAL_REQ_FIFO(CHAN_NUM_MemreadRequestProxy_startRead)] = buf[i];
	};
	/*sem_wait(&test_sem);*/
	bdbm_msg ("wait until reads finish!");
	down_interruptible (&test_sem);
	bdbm_msg ("wait done!");

	while (1) {	msleep(1); if (kthread_should_stop()) break; }

	return 0;
}
/*
 * EDN
 */

int bdbm_test_thread_fn (void* arg) 
{
	bdbm_msg ("kthread starts");

	while (1) {
		bdbm_msg ("kthread is running");

		mdelay(500); 
		msleep(1);

		if (kthread_should_stop()) {
			return 0;
		}
	}
	return 0;
}

int bdbm_test_memread_thread_init (void) 
{
	/*if ((thread1 = kthread_create (bdbm_test_thread_simman_fn, NULL, "kthread"))) {*/
	if ((thread1 = kthread_create (bdbm_test_thread_memread_fn, NULL, "kthread"))) {
		wake_up_process (thread1);

		if ((tid = kthread_create (kthread_worker, NULL, "kthread_worker")) == NULL) {
			bdbm_error ("kthread_create failed");
			return 0;
		}

	} else {
		bdbm_error ("kthread_create failed");
	}
	return 0;
}

void bdbm_test_memread_thread_cleanup (void) 
{
	if (tid) {
		kthread_stop (tid);
		tid = NULL;
	}

	if (!kthread_stop (thread1)) {
		bdbm_msg ("kthread stops");
	}
}

