#ifndef _BLUEDBM_FILE_H
#define _BLUEDBM_FILE_H

#include <linux/fs.h>
#include <asm/segment.h>
#include <asm/uaccess.h>
#include <linux/buffer_head.h>

struct file* bdbm_fopen (const char* path, int flags, int rights);
void bdbm_fclose (struct file* file);
uint64_t bdbm_fread (struct file* file, uint64_t offset, uint8_t* data, uint64_t size);
uint64_t bdbm_fwrite (struct file* file, uint64_t offset, uint8_t* data, uint64_t size);
uint32_t bdbm_fsync (struct file* file);
uint32_t bdbm_funlink (struct file* file);
void bdbm_flog (const char* filename, char* string);

#endif
